<?

/*
Plugin Name: Graf Dashboard Widget
Plugin URI: http://thexnews.com/?p=250
Description: Adds Widget with custom HTML code to your dashboard.
Author: Dmitry Graf
Version: 0.1
Author URI: http://thexnews.com/
*/ 

function graf_dashboard() {
  $graf_dashboard_text=get_option("grafs_dashboard_0_text");
  if ($graf_dashboard_text=="") {$graf_dashboard_text="Please <a href='?edit=graf_dashboard#graf_dashboard'>configure</a> this widget!";}
  echo stripcslashes($graf_dashboard_text);
}

function graf_register_dashboard_widget() {
  $graf_dashboard_name=get_option("grafs_dashboard_0_name");
  if ($graf_dashboard_name=="") {$graf_dashboard_name="Graf Dashboard Widget";}
        wp_register_sidebar_widget( 'graf_dashboard', $graf_dashboard_name, 'graf_dashboard', array(
                'width' => 'full'
        ) );
        wp_register_widget_control( 'graf_dashboard', $graf_dashboard_name, 'graf_register_dashboard_widget_control', array(), array(
                'widget_id' => 'graf_dashboard',
        ) );

}


function graf_register_dashboard_widget_control() {
        if ( 'post' == strtolower($_SERVER['REQUEST_METHOD']) && isset( $_POST['widget_id'] ) && 'graf_dashboard' == $_POST['widget_id'] ) {
           update_option( 'grafs_dashboard_0_name', $_POST['grafs_dashboard_0_name'] );
           update_option( 'grafs_dashboard_0_text', $_POST['grafs_dashboard_0_text'] );
        }

  $gname=get_option("grafs_dashboard_0_name");
  $gtext=stripslashes(get_option("grafs_dashboard_0_text"));

  echo "<p><label for='grafs_dashboard_0_name'>Name:</label><input type='text' style='width:100%' name='grafs_dashboard_0_name' id='grafs_dashboard_0_name' value='$gname'></p>";
  echo "<p><label for='grafs_dashboard_0_text'>Text:</label><textarea style='width:100%; height:100px;' name='grafs_dashboard_0_text' id='grafs_dashboard_0_text'>$gtext</textarea></p>";
}

function graf_add_dashboard_widget( $widgets ) {
        global $wp_registered_widgets;
        if ( !isset($wp_registered_widgets['graf_dashboard']) || !current_user_can( 'manage_options' ) )
                return $widgets;

        array_splice( $widgets, 2, 0, 'graf_dashboard' );
        return $widgets;
}

add_action( 'wp_dashboard_setup', 'graf_register_dashboard_widget' );
add_filter( 'wp_dashboard_widgets', 'graf_add_dashboard_widget' );
 ?>